﻿function MManager(model_param, gui_param){
	this.model = model_param?model_param:false;
	this.gui = gui_param?gui_param:false;
	if(model_param && gui_param) {
		this.check_model();
		this.gui.show_mods();
	}
	this.generators_set = [];
	this.current_gen = 0;
}

MManager.prototype.next_generator = function(){
	if(this.current_gen!=this.generators_set.length-1)this.current_gen++;
	this.gui.show_bmd(this.model.bmd_accord[this.generators_set[this.current_gen]], this.model.device_settings);
}
MManager.prototype.previous_generator = function(){
	if(this.current_gen!=0)this.current_gen--;
	this.gui.show_bmd(this.model.bmd_accord[this.generators_set[this.current_gen]], this.model.device_settings);
}
MManager.prototype.justify_bmd = function(){
	var tbse = $("#bmd_setting");
	if(tbse.hasClass("hidden")){
		var toba = this.model.bmd_accord;
		this.model.bmd_accord = [];
		this.generators_set = [];
		this.current_gen = 0;
		var tigen = [];
		var tieng = [];
		
		for(var i=_g1;i<=_g2;i++){
			var tr = this.model.devices_mapper_2[i];
			if(tr)tigen.push(tr);
		}
		
		if(tigen.length>0){
			for(var i=devices.length;i<=(devices.length + engines.length);i++){
				var tr = this.model.devices_mapper_2[i];
				if(tr)tieng.push(tr);
			}
			if(tieng.length>0){
				for(var i=0;i<tigen.length;i++) if(tigen[i])
				for(var j=0;j<tigen[i].length;j++) {
					var tdv = tigen[i][j];
					this.model.bmd_accord[tdv]={gen_lnk:tdv, engines_arr:tieng};
					this.generators_set.push(tdv);
				}
				this.gui.show_bmd(this.model.bmd_accord[this.generators_set[this.current_gen]], this.model.device_settings);
			}
		}
	}
	this.gui.lever_class(tbse,"hidden");
}

MManager.prototype.put_device = function(event_param, addendum_param){
	var tbse = $("#bmd_setting");
	if(!tbse.hasClass("hidden"))tbse.addClass("hidden");
	
	var selected_number = $(event_param.target).attr("value")*1;
	var ssi=this.model.selected_segment_index;
	var tdl = selected_number + addendum_param;
	if(selected_number>-1 && ssi>-1){
		this.install_device(tdl, ssi);
		if(tdl==_g1 || tdl==_g2) this.check_bmd();
	}
	this.gui.unselect_menu();
}
MManager.prototype.put_armorshield = function(event_param){
	this.put_device(event_param, devices.length + engines.length + batteries.length + weapons.length + armor_plates_1.length);
	this.gui.unselect_menu();
}
MManager.prototype.put_armorplate1 = function(event_param){
	this.put_device(event_param, devices.length + engines.length + batteries.length + weapons.length);
	this.gui.unselect_menu();
}
MManager.prototype.put_armorplate2 = function(event_param){
	this.put_device(event_param, devices.length + engines.length + batteries.length + weapons.length + armor_plates_1.length + armor_shields.length);
	this.gui.unselect_menu();
}
MManager.prototype.put_armorplate3 = function(event_param){
	this.put_device(event_param, devices.length + engines.length + batteries.length + weapons.length + armor_plates_1.length + armor_shields.length + armor_plates_2.length);
	this.gui.unselect_menu();
}
MManager.prototype.put_weapon = function(event_param){
	this.put_device(event_param, devices.length + engines.length + batteries.length);
	this.gui.unselect_menu();
}
MManager.prototype.put_battery = function(event_param){
	this.put_device(event_param, devices.length + engines.length);
	this.check_batteries_loading();
	this.gui.unselect_menu();
}
MManager.prototype.put_engine = function(event_param){
	this.put_device(event_param, devices.length);
	this.check_engines_workload();
	this.check_vacant_weight();
	this.gui.unselect_menu();
}


MManager.prototype.install_device = function(_device_link_param,_seg_link_param){
	var tst = this.model.get_segment_type(_seg_link_param)*1; 
	var tdo = this.model.get_default_device_object(_device_link_param);
	var tas = tdo.allowed_segments;
	var tst_in_tas = false;
	for(var i=0;i<tas.length && !tst_in_tas;i++) tst_in_tas = tas[i]==tst;
	if(tst_in_tas){
		var tdmc = tdo.attr[_max_count].value;
		if(typeof(tdmc)=="function") tdmc = tdmc.call(this.model);
		var tdct = this.model.devices_mapper[_device_link_param];
		var tca = tdo.controlled_area == _all_segments;
		var tdcc = tdct?(tca?tdct.length:this.model.get_device_amount_in_segment(_device_link_param,_seg_link_param)):0;
		//if(tdcc>tdmc)for(var i=0;i<tdcc-tdmc)this.remove_device(_seg_link_param,_device_link_param,);
		if(tdmc==-1 || (tdmc>0 && tdcc<tdmc)) {
			var tsc = 1;
			var tmsgm = [_seg_link_param];
			if(tdo.composite_name){
				tmsgm = this.model.seg_group_mapper[tst];
				tsc = tmsgm.length; //число сегментов данного типа
				if(tst==_sg_torso) if(tmsgm[1]==_seg_link_param) {
					tsc=1;
					tmsgm=[_seg_link_param];
				}else{ 
					tsc=2;
					tmsgm=[tmsgm[0],tmsgm[2]];
				}
				this.model.divider = tsc;
				var tcdc = tdo.attr[_size].value;
				tcdc = typeof(tcdc)=="function"?tcdc.call(this.model):tcdc;
				if(tcdc%1!=0 && tcdc%0.5!=0) return alert("Невозможно распределить оборудование по сегментам");
			}
			for(var i=0;i<tsc;i++){
				var tcsegi = tmsgm[i];
				var a = this.model.install_device(_device_link_param,tcsegi); //кол-во девайсов данного типа
				
				//зависит ли данный девайс от других контроллеров
				var functional = this.model.is_the_device_functional(tdo,tcsegi);
				
				//зависят ли другие девайсы от данного
				this.check_devices_under_control_of(_device_link_param,tcsegi, _installing);
				
				var tdt = this.model.get_device_type(_device_link_param);
				this.gui.show_device(_device_link_param, tcsegi, a, functional, tdt, this.model.get_rk());
			}
			this.standard_model_test();
		}else alert("Число устройств данного типа не должно превышать "+tdmc);
	}else alert("Устройство нельзя устанавливать в этот сегмент");
}

MManager.prototype.put_default_devices = function(default_devices_param){
	if(this.model.segments.length>0)
	for(var i in default_devices_param) if (default_devices_param.hasOwnProperty(i)) {//перебор устанавливаемых по умолчанию девайсов
		var gs = devices[default_devices_param[i]].installed_in_segments; //alert(i+": "+gs);
		//перебор ГРУПП сегментов в которые нужно установить девайсы
		for(var j=0;j<gs.length;j++) {
			var sg_map = this.model.seg_group_mapper;
			if(sg_map.hasOwnProperty(gs[j])) 
			for(var k=0; k<sg_map[gs[j]].length;k++) {//перебор сегментов для установки девайса
				this.install_device(i,sg_map[gs[j]][k]);
			}
		}
	}
	this.check_control_lock_threshold();
}

MManager.prototype.set_model_material = function(event_param){
	var selected_number = $(event_param.target).attr("value");
	if(selected_number>-1){
		this.model.set_material(selected_number);
		this.check_material();
		
		this.check_safety_warming();
		this.standard_model_test();
		
		this.gui.unselect_menu(); 
	}
}

MManager.prototype.set_model_rk = function(event_param){
	var selected_number = $(event_param.target).attr("value")*1;
	if(selected_number>-1 && selected_number!=this.model.get_rk()){
		if(this.model.is_mod_toggled(_special_order)) this.unit_set_modification(_special_order);
		this.model.set_rk(selected_number);
		this.check_rk();
		this.check_safety_warming();
		this.standard_model_test();
		
		this.gui.unselect_menu();
	}
}

MManager.prototype.set_model_structure = function(event_param){
	var selected_number = $(event_param.target).attr("value");
	if(selected_number>-1){
		this.select_segment(this.model.selected_segment_index);
		this.model.set_structure(selected_number);
		this.check_structure();
		this.gui.show_segments(this.model.segments);
		
		this.put_default_devices(this.model.default_devices_map);
		
		this.standard_model_test();
		this.check_batteries_loading();
		this.check_engines_workload();
		
		this.gui.unselect_menu();
	}
}

MManager.prototype.set_model_name = function(name_param){
	this.model.set_name(name_param);
	this.gui.unselect_menu();
	this.check_unit_name();
}

//checkers
MManager.prototype.check_model = function(){
	this.check_unit_name();
	this.check_structure();
	this.check_rk();
	this.check_material();
	this.check_safety_warming();
	this.check_engines_workload();
	this.check_unit_capacity();
	this.check_total_weight();
	this.check_total_price();
	this.check_batteries_loading();
	//
}

MManager.prototype.check_parameter = function(check_value_param,status_element_param){
	if(check_value_param){
		this.gui.show_status(status_element_param,_ok_status);return true;
	}else{
		this.gui.show_status(status_element_param,_warning_status);return false;
	}
}
MManager.prototype.check_total_price = function(){
	var tmp = this.model.get_total_price().toFixed(1);
	var trk = this.model.get_rk();
	var tnp = nominal_prices[trk-3];
	this.gui.show_parameter(_unit_total_price_element, tmp+' / '+(trk?(tnp[0]==tnp[1]?tnp[0]/1000+'k':tnp[0]/1000+'k'+'-'+tnp[1]/1000+'k'):'-'));
	return this.check_parameter(trk && tmp>tnp[0]-price_deviation && tmp<=tnp[1],_unit_total_price_status);
}
MManager.prototype.check_unit_capacity = function(){
	var ttc = this.model.get_total_capacity();
	var toc = this.model.get_occupied_capacity();
	this.gui.show_parameter(_unit_capacity_element, toc+'/'+ttc);
	return this.check_parameter(ttc>0 && ttc==toc,_unit_capacity_status);
}
MManager.prototype.check_unit_speed = function(){ 
	var ws = this.model.get_walking_speed();
	var rs = this.model.get_run_speed();
	this.gui.show_parameter(_unit_speed_element, ws+'/'+rs);
	return this.check_parameter(ws>0 || (ws=0 && rs>0),_unit_speed_status);
}
MManager.prototype.check_vacant_weight = function(){
	this.check_unit_speed();
	var tvw = this.model.get_vacant_weight();
	this.gui.show_parameter(_vacant_weight_element, tvw);
	return this.check_parameter(tvw, _vacant_weight_status);
}
MManager.prototype.check_total_weight = function(){
	this.check_vacant_weight();
	this.check_massive_damage();
	var ttw = this.model.get_total_weight();
	this.gui.show_parameter(_total_weight_element, ttw);
	return this.check_parameter(ttw,_total_weight_status);
}
MManager.prototype.check_power_threshold = function(){
	this.gui.show_parameter(_power_threshold_element, this.model.get_power_threshold());
	return this.check_parameter(this.model.get_engines_workload(),_power_threshold_status);
}
MManager.prototype.check_engines_workload = function(){
	this.check_power_threshold();
	this.check_unit_speed();
	this.check_bmd();
	var tew = this.model.get_engines_workload();
	this.gui.show_parameter(_engines_workload_element, tew);
	return this.check_parameter(tew,_engines_workload_status);
}
MManager.prototype.check_bmd = function(){
	var generators = [_g1,_g2];
	var res = true;
	for(var i=0;i<generators.length;i++){
		var tgi = generators[i];
		if(this.model.device_in_unit(tgi)){
			var td = devices[tgi];
			var tdc = td.attr[_size].value.call(this.model);
			res = res && (tdc%1==0 || tdc%0.5==0);
		}
	}
	var tmn = this.model.attr[_bmd].value;
	this.gui.show_parameter(_bmd_element, tmn);
	return this.check_parameter(res,_bmd_status);
}
MManager.prototype.check_unit_name = function(){
	var tmn = this.model.get_name();
	this.gui.show_parameter(_unit_name_element, tmn);
	return this.check_parameter(tmn,_unit_name_status);
}
MManager.prototype.check_batteries_loading = function(){
	var tbl = this.model.get_total_battery_load();
	this.gui.show_parameter(_battery_load_element, tbl);
	return this.check_parameter(tbl>0,_battery_load_status);
}
MManager.prototype.check_massive_damage = function(){
	var tmd = this.model.get_massive_damage();
	this.gui.show_parameter(_massive_damage_element, tmd);
	return this.check_parameter(tmd>0,_massive_damage_status);
}
MManager.prototype.check_material = function(){
	this.gui.show_parameter(_material_type_element, this.model.get_material_type());
	return this.check_parameter(this.model.material,_material_status);
}
MManager.prototype.check_rk = function(){
	var trk = this.model.get_rk();
	this.gui.show_parameter(_rk_value_element, trk);
	return this.check_parameter(trk,_rk_status);
}
MManager.prototype.check_structure = function(){
	this.gui.show_parameter(_structure_name_element, this.model.get_structure_type());
	return this.check_parameter(this.model.structure,_structure_status);
}
MManager.prototype.check_safety_warming = function(){
	if(this.model.set_safety_warming())
		this.gui.show_parameter(_safety_warming_value_element, this.model.get_safety_warming());
	this.check_control_lock_threshold();
	return this.check_parameter(this.model.get_safety_warming(),_safety_warming_status);
}
MManager.prototype.check_control_lock_threshold = function(){
	this.gui.show_parameter(_control_lock_threshold_element, this.model.get_control_lock_threshold());
	return this.check_parameter(this.model.get_safety_warming(),_control_lock_threshold_status);
}

MManager.prototype.parse_click = function(target_param){
	var f = $(target_param); 
	if (f.hasClass("remove_button")) {
		this.remove_device(f.attr("sgmt_indx")*1,f.attr("dvc_indx")*1,f.attr("dev_el_indx"));
	}else if (f.hasClass("mod_title")) {
		var mi = f.attr("mod_idx")*1;
		var ul = $("#mod_details_"+mi);
		this.gui.select_mod_details(mi,ul);
	}else if (f.hasClass("mod_toggle_button")){
		var mi = f.attr("mod_idx")*1;
		this.unit_set_modification(mi);
		this.gui.unselect_mod_details();
	}else if (f.hasClass("segment_icon")) {
		var ss = f.attr("value")*1;
		this.select_segment(ss);
	}else if (f.hasClass("d_option")){
		var tdi = f.attr("dvc_idx")*1;
		var tcoi = f.attr("opn_idx")*1;
		var tsoi = f.attr("opt_idx")*1+1;
		var tdsi = f.attr("dev_set");
		var cur_dvc = this.model.get_default_device_object(tdi);
		var co = cur_dvc.options[tcoi];
		if(tsoi>=co.length) tsoi = 0;
		if(tsoi==0) f.removeClass("selected_doption"); else f.addClass("selected_doption");
		f.attr("opt_idx",tsoi).text('['+co[tsoi].name+']');
		this.model.update_device_setting(tdi,tdsi,tcoi,tsoi);
		this.check_engines_workload();
		this.standard_model_test();
	}
}

MManager.prototype.select_segment = function(seg_num_param) {
	var ds = this.model.select_segment(seg_num_param);
	this.gui.lever_class($("#segment_"+seg_num_param),"selected_segment");
	if(ds!=-1 && seg_num_param!=ds)this.gui.lever_class($("#segment_"+ds),"selected_segment");
	if(this.model.selected_segment_index > -1) {
		$("#dev_choices").removeClass("hidden");
		$("#armor_choice_holder").removeClass("hidden");
	}else{
		$("#dev_choices").addClass("hidden");
		$("#armor_choice_holder").addClass("hidden");
	}
}

MManager.prototype.unit_set_modification =function(mod_idx_param){
	var mh = $("#mod_holder_"+mod_idx_param);
	this.gui.lever_class($(".mod_toggle_button",mh),"pressed");
	this.gui.lever_class(mh,"enabled");
	var tmo = mods[mod_idx_param].operations;
	for(var i=0;i<tmo.length;i++){ 
		if(tmo[i].user_input){
			var tv = $("#mod_details_"+mod_idx_param+" input").val();
			if(!isNaN(tv)) tmo[i].value = tv*1;
			if(tmo[i].value_function) tmo[i].value = tmo[i].value_function.call(this.model);
		}
	}
	this.model.set_modification(mod_idx_param);
	this.check_safety_warming();
	this.standard_model_test();
	$(".mod_details",mh).remove();
	mh.append(this.gui.get_mod_details(mod_idx_param));
}
MManager.prototype.get_holder_id_for_devices = function(device_type_param){
	var result = 
		device_type_param==_device ?  "#devices_holder_" :
		device_type_param==_engine ?  "#engines_holder_" :
		device_type_param==_battery ? "#batteries_holder_" :
		device_type_param==_weapon ? "#weapons_holder_" :
		device_type_param==_armor1 ? "#armor1_holder_" :
		device_type_param==_shield ? "#armor1_holder_" :
		device_type_param==_armor2 ? "#armor1_holder_" :
		device_type_param==_armor3 ? "#armor1_holder_" :
		'';
	return result;
}
MManager.prototype.remove_device = function(segment_index_param, device_index_param, device_element_index_param){
	var tbse = $("#bmd_setting");
	if(!tbse.hasClass("hidden"))tbse.addClass("hidden");
	
	var tdi = device_index_param*1;
	var tdt = this.model.get_device_type(tdi);
	var tholder = this.get_holder_id_for_devices(tdt);
	
	var exist_any_segment_with_the_device = this.model.get_segments_with_device(tdi);
	if (exist_any_segment_with_the_device){
		var tcd = '' + tdi + device_element_index_param;
		$("#device_"+tcd, tholder + segment_index_param).remove();
		this.model.remove_device_from_segment(tdi,segment_index_param,tcd);
		switch(tdt){
			case _device:
				this.check_devices_under_control_of(tdi, segment_index_param, _removing);
				break;
			case _engine:
				this.check_engines_workload();
				break;
			case _battery:
				this.check_batteries_loading();
				break;
		}
		this.standard_model_test();
		switch(tdi){
			case _control_lock_device: 
				this.check_control_lock_threshold();
				break;
			case _g1: case _g2:
				this.check_bmd();
				break;
		}
	}
}
MManager.prototype.check_devices_under_control_of = function(dev_idx_p, seg_idx_p, applying_type_p){ 
	if(dev_idx_p<devices.length){
		var tdt = this.model.get_device_type(dev_idx_p);
		var tholder = this.get_holder_id_for_devices(tdt);
		var cid = devices[dev_idx_p].controlled_area==_all_segments?".segments_holder":tholder + seg_idx_p;
		
		//если есть подконтрольные устройства и нет другого контролирующего устройства
		var a = this.model.get_devices_controlled_by(dev_idx_p);//подконтрольные девайсы
		if(a) for(var i=0; i<a.length; i++){
			var td = this.model.get_default_device_object(a[i]);
			var functional = this.model.is_the_device_functional(td, seg_idx_p);
			if(applying_type_p && functional){
				$(".device_holder[dev_idx="+a[i]+"]",cid).removeClass("nonfunctional");
			}else if(!applying_type_p && !functional){
				$(".device_holder[dev_idx="+a[i]+"]",cid).addClass("nonfunctional");
			}
		}
	}
}
MManager.prototype.standard_model_test = function(){
	this.check_unit_capacity();
	this.redraw_hit_points();
	this.check_total_weight(); //вес проверяется после установки хитпоинтов
	this.check_total_price();
}
MManager.prototype.redraw_hit_points = function(){
	if(this.model.structure){
		var empty_segments_number = this.gui.redraw_hit_points(this.model.segments);
		var tmsc = this.model.structure.config;
		var chassis_segments_number = tmsc[6] + tmsc[8] + tmsc[9];
		if(chassis_segments_number>0 && empty_segments_number>chassis_segments_number){
			this.gui.show_system_message("Число пустых сегментов не может превышать "+chassis_segments_number);
		}else{
			this.gui.show_system_message('');
		}
	}
}